Name:           maven-release
Version:        4
Release:        1%{?dist}
Summary:        Maven Release

Group:          Development/Tools
License:        ASL 2.0
URL:            http://maven.apache.org/plugins/maven-release-plugin/
# svn export \
#  http://svn.apache.org/repos/asf/maven/release/tags/maven-release-4
# tar cjf maven-release-4.tar.bz2 maven-release-4
Source0:        %{name}-%{version}.tar.bz2
# ATM we don't want to have to package jmock1, cglib, and objectweb-asm1 so
# patch out running of the tests
Source1:        %{name}-jpp-depmap.xml
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch: noarch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Provides:        %{name}-manager

%description
Maven Release manager is used to perform releases using Maven.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
API documentation for %{name}.

%package -n maven-plugin-release
Group:          Development/Tools
Summary:        Maven Release plugin
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description -n maven-plugin-release
This is the Maven plugin for releasing projects with Maven Release manager.

%prep
%setup -q -n %{name}-%{version}

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
# skipping tests due to need for jmock1, objectweb-asm1, and cglib packages
mvn-jpp \
        -e \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        install javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
install -m 644 \
  maven-release-manager/target/maven-release-manager-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.apache.maven.release maven-release %{version} JPP maven-release
%add_to_maven_depmap org.apache.maven.release maven-release-manager %{version} JPP maven-release-manager

# plugin
install -m 644 \
  maven-release-plugin/target/maven-release-plugin-%{version}.jar \
  %{buildroot}%{_javadir}/maven-plugin-release-%{version}.jar
%add_to_maven_depmap org.apache.maven.plugins maven-release-plugin %{version} JPP maven-plugin-release

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}.pom
install -pm 644 maven-release-manager/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-manager.pom
install -pm 644 maven-release-plugin/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.maven-plugin-release.pom

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; \
    do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
rm -rf target/site/api*

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post -n maven-plugin-release
%update_maven_depmap

%postun -n maven-plugin-release
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files -n maven-plugin-release
%defattr(-,root,root,-)
%{_javadir}/maven-plugin-release*.jar

%changelog
* Fri Sep 11 2009 Andrew Overholt <overholt@redhat.com> 4-1
- Initial release of combined manager and plugin
